/* This is an autogenerated file from sme__remote_client_interface_c */
/* Tag: noCheckHeader */

/*    CONFIDENTIAL */
/*    Copyright (C) Cambridge Silicon Radio Ltd 2008. All rights reserved. */

/* This is an autogenerated file from sme__remote_client_interface_c.pl */


#include "fsm/fsm.h" 
#include "fsm/fsm_types.h" 
#include "hostio/hip_fsm_types.h"
#include "smeio/smeio_fsm_types.h"
#include "smeio/smeio_fsm_events.h"
#include "event_pack_unpack/event_pack_unpack.h"
#include "mgt_sap/mgt_sap.h" 
#include "mgt_sap/mgt_sap_remote_sme_interface.h" 

static void event_to_unifi_mgt_wifi_on_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtWifiOnCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */

    unifi_mgt_wifi_on_cfm(context, evt.status);

}

static void event_to_unifi_mgt_wifi_off_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtWifiOffCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */

    unifi_mgt_wifi_off_cfm(context, evt.status);

}

static void event_to_unifi_mgt_wifi_off_ind(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtWifiOffInd_Evt evt;
    /*lint -save -e545 -e725 */
    evt.controlIndication = event_unpack_uint16(&buffer); /* unifi_ControlIndication : controlIndication */

    unifi_mgt_wifi_off_ind(context, evt.controlIndication);

}

static void event_to_unifi_mgt_wifi_flightmode_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtWifiFlightmodeCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */

    unifi_mgt_wifi_flightmode_cfm(context, evt.status);

}

static void event_to_unifi_mgt_set_value_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtSetValueCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */
    /*lint -save -e545 -e725 */
    evt.appValueId = event_unpack_uint16(&buffer); /* unifi_AppValueId : appValueId */

    unifi_mgt_set_value_cfm(context, evt.status, evt.appValueId);

}

static void event_to_unifi_mgt_get_value_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtGetValueCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */
    /*lint -save -e545 -e725 */
    evt.appValue.id = event_unpack_uint16(&buffer); /* unifi_AppValueId : id */
    /* -----------------------------------------------------------------*/
    /* A UNION  :: unifi_Value_union*/
    /* -----------------------------------------------------------------*/
    switch(evt.appValue.id)
    {
    case unifi_AdHocConfigValue:
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.adHocConfig.atimWindow = event_unpack_uint16(&buffer); /* uint16 : atimWindow */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.adHocConfig.beaconPeriod = event_unpack_uint16(&buffer); /* uint16 : beaconPeriod */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.adHocConfig.defaultChannelNumber = event_unpack_uint8(&buffer); /* uint8 : defaultChannelNumber */
        break;
    case unifi_CalibrationDataValue:
        evt.appValue.unifi_Value_union.calibrationData.length = event_unpack_uint16(&buffer); /*lint !e725 unifi_DataBlock : calibrationData */
        evt.appValue.unifi_Value_union.calibrationData.data = NULL;
        if (evt.appValue.unifi_Value_union.calibrationData.length)
        {
            evt.appValue.unifi_Value_union.calibrationData.data = (uint8*)osa_malloc(evt.appValue.unifi_Value_union.calibrationData.length); /*lint !e725 unifi_DataBlock : calibrationData*/
            /*lint -save -e545 -e725 */
            event_unpack_buffer(&buffer, evt.appValue.unifi_Value_union.calibrationData.data, evt.appValue.unifi_Value_union.calibrationData.length); /*lint !e545 !e725 unifi_DataBlock : calibrationData */
        }
        break;
    case unifi_CoexConfigValue:
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexConfig.coexEnable = event_unpack_int16(&buffer); /* Boolean : coexEnable */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexConfig.coexAfhChannelEnable = event_unpack_int16(&buffer); /* Boolean : coexAfhChannelEnable */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexConfig.coexAdvancedEnable = event_unpack_int16(&buffer); /* Boolean : coexAdvancedEnable */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexConfig.coexEnableSchemeManagement = event_unpack_int16(&buffer); /* Boolean : coexEnableSchemeManagement */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexConfig.coexDirection = event_unpack_uint16(&buffer); /* unifi_CoexDirection : coexDirection */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexConfig.coexPeriodicWakeHost = event_unpack_int16(&buffer); /* Boolean : coexPeriodicWakeHost */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexConfig.coexTrafficBurstyLatencyMs = event_unpack_uint16(&buffer); /* uint16 : coexTrafficBurstyLatencyMs */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexConfig.coexTrafficContinuousLatencyMs = event_unpack_uint16(&buffer); /* uint16 : coexTrafficContinuousLatencyMs */
        break;
    case unifi_CoexInfoValue:
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexInfo.hasTrafficData = event_unpack_int16(&buffer); /* Boolean : hasTrafficData */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexInfo.currentTrafficType = event_unpack_uint16(&buffer); /* unifi_traffic_type : currentTrafficType */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexInfo.currentPeriod = event_unpack_uint16(&buffer); /* uint16 : currentPeriod */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexInfo.currentPowerSave = event_unpack_uint16(&buffer); /* unifi_PowerSaveLevel : currentPowerSave */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexInfo.currentCoexPeriod = event_unpack_uint16(&buffer); /* uint16 : currentCoexPeriod */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexInfo.currentCoexLatency = event_unpack_uint16(&buffer); /* uint16 : currentCoexLatency */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexInfo.hasBtDevice = event_unpack_int16(&buffer); /* Boolean : hasBtDevice */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexInfo.mibValuesSet = event_unpack_int16(&buffer); /* Boolean : mibValuesSet */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexInfo.currentPeriodicPIOInputOffset = event_unpack_uint16(&buffer); /* uint16 : currentPeriodicPIOInputOffset */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexInfo.currentPeriodicPIOInputDuration = event_unpack_uint16(&buffer); /* uint16 : currentPeriodicPIOInputDuration */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexInfo.currentPeriodicPIOInputPeriod = event_unpack_uint16(&buffer); /* uint16 : currentPeriodicPIOInputPeriod */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.coexInfo.currentCoexScheme = event_unpack_uint16(&buffer); /* unifi_CoexScheme : currentCoexScheme */
        break;
    case unifi_ConnectionConfigValue:
        /*lint -save -e545 -e725 */
        event_unpack_buffer(&buffer, (uint8*)&evt.appValue.unifi_Value_union.connectionConfig.ssid.ssid, 32); /*lint !e545 !e725  uint8 : ssid */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionConfig.ssid.length = event_unpack_uint8(&buffer); /* uint8 : length */
        /*lint -save -e545 -e725 */
        event_unpack_buffer(&buffer, (uint8*)&evt.appValue.unifi_Value_union.connectionConfig.bssid.data, 6); /*lint !e545 !e725  uint8 : data */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionConfig.bssType = event_unpack_uint16(&buffer); /* unifi_BSSType : bssType */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionConfig.privacyMode = event_unpack_uint16(&buffer); /* unifi_80211_PrivacyMode : privacyMode */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionConfig.authMode = event_unpack_uint16(&buffer); /* uint16 : authMode */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionConfig.encryptionMode = event_unpack_uint16(&buffer); /* uint16 : encryptionMode */
        evt.appValue.unifi_Value_union.connectionConfig.mlmeAssociateReqInformationElements.length = event_unpack_uint16(&buffer); /*lint !e725 unifi_DataBlock : mlmeAssociateReqInformationElements */
        evt.appValue.unifi_Value_union.connectionConfig.mlmeAssociateReqInformationElements.data = NULL;
        if (evt.appValue.unifi_Value_union.connectionConfig.mlmeAssociateReqInformationElements.length)
        {
            evt.appValue.unifi_Value_union.connectionConfig.mlmeAssociateReqInformationElements.data = (uint8*)osa_malloc(evt.appValue.unifi_Value_union.connectionConfig.mlmeAssociateReqInformationElements.length); /*lint !e725 unifi_DataBlock : mlmeAssociateReqInformationElements*/
            /*lint -save -e545 -e725 */
            event_unpack_buffer(&buffer, evt.appValue.unifi_Value_union.connectionConfig.mlmeAssociateReqInformationElements.data, evt.appValue.unifi_Value_union.connectionConfig.mlmeAssociateReqInformationElements.length); /*lint !e545 !e725 unifi_DataBlock : mlmeAssociateReqInformationElements */
        }
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionConfig.wmmQosInfo = event_unpack_uint8(&buffer); /* uint8 : wmmQosInfo */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionConfig.adhocChannel = event_unpack_uint8(&buffer); /* uint8 : adhocChannel */
        break;
    case unifi_ConnectionInfoValue:
        /*lint -save -e545 -e725 */
        event_unpack_buffer(&buffer, (uint8*)&evt.appValue.unifi_Value_union.connectionInfo.ssid.ssid, 32); /*lint !e545 !e725  uint8 : ssid */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionInfo.ssid.length = event_unpack_uint8(&buffer); /* uint8 : length */
        /*lint -save -e545 -e725 */
        event_unpack_buffer(&buffer, (uint8*)&evt.appValue.unifi_Value_union.connectionInfo.bssid.data, 6); /*lint !e545 !e725  uint8 : data */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionInfo.networkType80211 = event_unpack_uint16(&buffer); /* unifi_80211_NetworkType : networkType80211 */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionInfo.channelNumber = event_unpack_uint8(&buffer); /* uint8 : channelNumber */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionInfo.channelFrequency = event_unpack_uint16(&buffer); /* uint16 : channelFrequency */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionInfo.authMode = event_unpack_uint16(&buffer); /* unifi_AuthMode : authMode */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionInfo.ifIndex = event_unpack_uint16(&buffer); /* unifi_RadioIF : ifIndex */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionInfo.atimWindow = event_unpack_uint16(&buffer); /* uint16 : atimWindow */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionInfo.beaconPeriod = event_unpack_uint16(&buffer); /* uint16 : beaconPeriod */
        evt.appValue.unifi_Value_union.connectionInfo.assocScanInfoElements.length = event_unpack_uint16(&buffer); /*lint !e725 unifi_DataBlock : assocScanInfoElements */
        evt.appValue.unifi_Value_union.connectionInfo.assocScanInfoElements.data = NULL;
        if (evt.appValue.unifi_Value_union.connectionInfo.assocScanInfoElements.length)
        {
            evt.appValue.unifi_Value_union.connectionInfo.assocScanInfoElements.data = (uint8*)osa_malloc(evt.appValue.unifi_Value_union.connectionInfo.assocScanInfoElements.length); /*lint !e725 unifi_DataBlock : assocScanInfoElements*/
            /*lint -save -e545 -e725 */
            event_unpack_buffer(&buffer, evt.appValue.unifi_Value_union.connectionInfo.assocScanInfoElements.data, evt.appValue.unifi_Value_union.connectionInfo.assocScanInfoElements.length); /*lint !e545 !e725 unifi_DataBlock : assocScanInfoElements */
        }
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionInfo.assocReqCapabilities = event_unpack_uint16(&buffer); /* uint16 : assocReqCapabilities */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionInfo.assocReqListenInterval = event_unpack_uint16(&buffer); /* uint16 : assocReqListenInterval */
        /*lint -save -e545 -e725 */
        event_unpack_buffer(&buffer, (uint8*)&evt.appValue.unifi_Value_union.connectionInfo.assocReqApAddress.data, 6); /*lint !e545 !e725  uint8 : data */
        evt.appValue.unifi_Value_union.connectionInfo.assocReqInfoElements.length = event_unpack_uint16(&buffer); /*lint !e725 unifi_DataBlock : assocReqInfoElements */
        evt.appValue.unifi_Value_union.connectionInfo.assocReqInfoElements.data = NULL;
        if (evt.appValue.unifi_Value_union.connectionInfo.assocReqInfoElements.length)
        {
            evt.appValue.unifi_Value_union.connectionInfo.assocReqInfoElements.data = (uint8*)osa_malloc(evt.appValue.unifi_Value_union.connectionInfo.assocReqInfoElements.length); /*lint !e725 unifi_DataBlock : assocReqInfoElements*/
            /*lint -save -e545 -e725 */
            event_unpack_buffer(&buffer, evt.appValue.unifi_Value_union.connectionInfo.assocReqInfoElements.data, evt.appValue.unifi_Value_union.connectionInfo.assocReqInfoElements.length); /*lint !e545 !e725 unifi_DataBlock : assocReqInfoElements */
        }
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionInfo.assocRspResult = event_unpack_uint16(&buffer); /* unifi_IEEE80211_Result : assocRspResult */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionInfo.assocRspCapabilityInfo = event_unpack_uint16(&buffer); /* uint16 : assocRspCapabilityInfo */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionInfo.assocRspAssociationId = event_unpack_uint16(&buffer); /* uint16 : assocRspAssociationId */
        evt.appValue.unifi_Value_union.connectionInfo.assocRspInfoElements.length = event_unpack_uint16(&buffer); /*lint !e725 unifi_DataBlock : assocRspInfoElements */
        evt.appValue.unifi_Value_union.connectionInfo.assocRspInfoElements.data = NULL;
        if (evt.appValue.unifi_Value_union.connectionInfo.assocRspInfoElements.length)
        {
            evt.appValue.unifi_Value_union.connectionInfo.assocRspInfoElements.data = (uint8*)osa_malloc(evt.appValue.unifi_Value_union.connectionInfo.assocRspInfoElements.length); /*lint !e725 unifi_DataBlock : assocRspInfoElements*/
            /*lint -save -e545 -e725 */
            event_unpack_buffer(&buffer, evt.appValue.unifi_Value_union.connectionInfo.assocRspInfoElements.data, evt.appValue.unifi_Value_union.connectionInfo.assocRspInfoElements.length); /*lint !e545 !e725 unifi_DataBlock : assocRspInfoElements */
        }
        break;
    case unifi_ConnectionStatsValue:
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionStats.unifiRSSI = event_unpack_int16(&buffer); /* int16 : unifiRSSI */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionStats.unifiSNR = event_unpack_int16(&buffer); /* int16 : unifiSNR */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionStats.unifiTxDataRate = event_unpack_uint8(&buffer); /* uint8 : unifiTxDataRate */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionStats.unifiRxDataRate = event_unpack_uint8(&buffer); /* uint8 : unifiRxDataRate */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionStats.dot11RetryCount = event_unpack_uint32(&buffer); /* uint32 : dot11RetryCount */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionStats.dot11MultipleRetryCount = event_unpack_uint32(&buffer); /* uint32 : dot11MultipleRetryCount */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionStats.dot11ACKFailureCount = event_unpack_uint32(&buffer); /* uint32 : dot11ACKFailureCount */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionStats.dot11FrameDuplicateCount = event_unpack_uint32(&buffer); /* uint32 : dot11FrameDuplicateCount */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionStats.dot11FCSErrorCount = event_unpack_uint32(&buffer); /* uint32 : dot11FCSErrorCount */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionStats.dot11RTSSuccessCount = event_unpack_uint32(&buffer); /* uint32 : dot11RTSSuccessCount */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionStats.dot11RTSFailureCount = event_unpack_uint32(&buffer); /* uint32 : dot11RTSFailureCount */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionStats.dot11ReceivedFragmentCount = event_unpack_uint32(&buffer); /* uint32 : dot11ReceivedFragmentCount */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.connectionStats.dot11TransmittedFragmentCount = event_unpack_uint32(&buffer); /* uint32 : dot11TransmittedFragmentCount */
        break;
    case unifi_HostConfigValue:
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.hostConfig.powerMode = event_unpack_uint16(&buffer); /* unifi_HostPowerMode : powerMode */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.hostConfig.applicationDataPeriodMs = event_unpack_uint16(&buffer); /* uint16 : applicationDataPeriodMs */
        break;
    case unifi_MIBConfigValue:
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.mibConfig.unifiFixMaxTxDataRate = event_unpack_int16(&buffer); /* Boolean : unifiFixMaxTxDataRate */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.mibConfig.unifiFixTxDataRate = event_unpack_uint8(&buffer); /* uint8 : unifiFixTxDataRate */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.mibConfig.dot11RTSThreshold = event_unpack_uint16(&buffer); /* uint16 : dot11RTSThreshold */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.mibConfig.dot11FragmentationThreshold = event_unpack_uint16(&buffer); /* uint16 : dot11FragmentationThreshold */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.mibConfig.dot11CurrentTxPowerLevel = event_unpack_uint16(&buffer); /* uint16 : dot11CurrentTxPowerLevel */
        break;
    case unifi_PermanentMacAddressValue:
        /*lint -save -e545 -e725 */
        event_unpack_buffer(&buffer, (uint8*)&evt.appValue.unifi_Value_union.permanentMacAddress.data, 6); /*lint !e545 !e725  uint8 : data */
        break;
    case unifi_PowerConfigValue:
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.powerConfig.powerSaveLevel = event_unpack_uint16(&buffer); /* unifi_PowerSaveLevel : powerSaveLevel */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.powerConfig.listenInterval = event_unpack_uint16(&buffer); /* uint16 : listenInterval */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.powerConfig.rxDtims = event_unpack_int16(&buffer); /* Boolean : rxDtims */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.powerConfig.d3autoScanMode = event_unpack_uint16(&buffer); /* unifi_D3AutoScanMode : d3autoScanMode */
        break;
    case unifi_RoamingConfigValue:
        {
        int i;
        for (i = 0; i < 3; i++)
        {
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.roamingConfig.roamingBands[i].rssiHighThreshold = event_unpack_int16(&buffer); /* int16 : rssiHighThreshold */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.roamingConfig.roamingBands[i].rssiLowThreshold = event_unpack_int16(&buffer); /* int16 : rssiLowThreshold */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.roamingConfig.roamingBands[i].snrHighThreshold = event_unpack_int16(&buffer); /* int16 : snrHighThreshold */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.roamingConfig.roamingBands[i].snrLowThreshold = event_unpack_int16(&buffer); /* int16 : snrLowThreshold */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.roamingConfig.roamingBands[i].monitorInterval = event_unpack_uint32(&buffer); /* uint32 : monitorInterval */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.roamingConfig.roamingBands[i].monitorWindow = event_unpack_uint32(&buffer); /* uint32 : monitorWindow */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.roamingConfig.roamingBands[i].dot11RetryRatio = event_unpack_uint8(&buffer); /* uint8 : dot11RetryRatio */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.roamingConfig.roamingBands[i].dot11MultipleRetryRatio = event_unpack_uint8(&buffer); /* uint8 : dot11MultipleRetryRatio */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.roamingConfig.roamingBands[i].dot11ACKFailureRatio = event_unpack_uint8(&buffer); /* uint8 : dot11ACKFailureRatio */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.roamingConfig.roamingBands[i].dot11FCSErrorRatio = event_unpack_uint8(&buffer); /* uint8 : dot11FCSErrorRatio */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.roamingConfig.roamingBands[i].dot11RTSFailureRatio = event_unpack_uint8(&buffer); /* uint8 : dot11RTSFailureRatio */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.roamingConfig.roamingBands[i].beaconLossThreshold = event_unpack_uint8(&buffer); /* uint8 : beaconLossThreshold */
        }
        }
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.roamingConfig.lowQualHystWindow = event_unpack_uint8(&buffer); /* uint8 : lowQualHystWindow */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.roamingConfig.apBlockTime = event_unpack_uint8(&buffer); /* uint8 : apBlockTime */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.roamingConfig.roamMonitorPeriod = event_unpack_uint8(&buffer); /* uint8 : roamMonitorPeriod */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.roamingConfig.roamNumMaxTh = event_unpack_uint8(&buffer); /* uint8 : roamNumMaxTh */
        break;
    case unifi_SMEConfigValue:
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.smeConfig.enablePmkidCanditateListIndications = event_unpack_int16(&buffer); /* Boolean : enablePmkidCanditateListIndications */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.smeConfig.connectionQualityRssiChangeTrigger = event_unpack_uint8(&buffer); /* uint8 : connectionQualityRssiChangeTrigger */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.smeConfig.connectionQualitySnrChangeTrigger = event_unpack_uint8(&buffer); /* uint8 : connectionQualitySnrChangeTrigger */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.smeConfig.trustLevel = event_unpack_uint16(&buffer); /* unifi_80211dTrustLevel : trustLevel */
        /*lint -save -e545 -e725 */
        event_unpack_buffer(&buffer, (uint8*)&evt.appValue.unifi_Value_union.smeConfig.countryCode, 2); /*lint !e545 !e725  uint8 : countryCode */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.smeConfig.wmmMode = event_unpack_uint16(&buffer); /* uint16 : wmmMode */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.smeConfig.ifIndex = event_unpack_uint16(&buffer); /* unifi_RadioIF : ifIndex */
        break;
    case unifi_ScanConfigValue:
        {
        int i;
        for (i = 0; i < 4; i++)
        {
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.scanControl.scanCfg[i].interval = event_unpack_uint16(&buffer); /* uint16 : interval */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.scanControl.scanCfg[i].validity = event_unpack_uint16(&buffer); /* uint16 : validity */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.scanControl.scanCfg[i].minActiveChannelTime = event_unpack_uint16(&buffer); /* uint16 : minActiveChannelTime */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.scanControl.scanCfg[i].maxActiveChannelTime = event_unpack_uint16(&buffer); /* uint16 : maxActiveChannelTime */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.scanControl.scanCfg[i].minPassiveChannelTime = event_unpack_uint16(&buffer); /* uint16 : minPassiveChannelTime */
            /*lint -save -e545 -e725 */
            evt.appValue.unifi_Value_union.scanControl.scanCfg[i].maxPassiveChannelTime = event_unpack_uint16(&buffer); /* uint16 : maxPassiveChannelTime */
        }
        }
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.scanControl.enableIndications = event_unpack_int16(&buffer); /* Boolean : enableIndications */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.scanControl.maxResults = event_unpack_uint16(&buffer); /* uint16 : maxResults */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.scanControl.highRSSIThreshold = event_unpack_int8(&buffer); /* int8 : highRSSIThreshold */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.scanControl.lowRSSIThreshold = event_unpack_int8(&buffer); /* int8 : lowRSSIThreshold */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.scanControl.deltaRSSIThreshold = event_unpack_int8(&buffer); /* int8 : deltaRSSIThreshold */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.scanControl.highSNRThreshold = event_unpack_int8(&buffer); /* int8 : highSNRThreshold */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.scanControl.lowSNRThreshold = event_unpack_int8(&buffer); /* int8 : lowSNRThreshold */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.scanControl.deltaSNRThreshold = event_unpack_int8(&buffer); /* int8 : deltaSNRThreshold */
        evt.appValue.unifi_Value_union.scanControl.passiveChannelList.length = event_unpack_uint16(&buffer); /*lint !e725 unifi_DataBlock : passiveChannelList */
        evt.appValue.unifi_Value_union.scanControl.passiveChannelList.data = NULL;
        if (evt.appValue.unifi_Value_union.scanControl.passiveChannelList.length)
        {
            evt.appValue.unifi_Value_union.scanControl.passiveChannelList.data = (uint8*)osa_malloc(evt.appValue.unifi_Value_union.scanControl.passiveChannelList.length); /*lint !e725 unifi_DataBlock : passiveChannelList*/
            /*lint -save -e545 -e725 */
            event_unpack_buffer(&buffer, evt.appValue.unifi_Value_union.scanControl.passiveChannelList.data, evt.appValue.unifi_Value_union.scanControl.passiveChannelList.length); /*lint !e545 !e725 unifi_DataBlock : passiveChannelList */
        }
        break;
    case unifi_StationMacAddressValue:
        /*lint -save -e545 -e725 */
        event_unpack_buffer(&buffer, (uint8*)&evt.appValue.unifi_Value_union.stationMacAddress.data, 6); /*lint !e545 !e725  uint8 : data */
        break;
    case unifi_VersionsValue:
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.versions.chipId = event_unpack_uint32(&buffer); /* uint32 : chipId */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.versions.chipVersion = event_unpack_uint32(&buffer); /* uint32 : chipVersion */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.versions.firmwareBuild = event_unpack_uint32(&buffer); /* uint32 : firmwareBuild */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.versions.firmwareHip = event_unpack_uint32(&buffer); /* uint32 : firmwareHip */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.versions.driverBuild = event_unpack_uint32(&buffer); /* uint32 : driverBuild */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.versions.driverHip = event_unpack_uint32(&buffer); /* uint32 : driverHip */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.versions.driverApi = event_unpack_uint32(&buffer); /* uint32 : driverApi */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.versions.smeBuild = event_unpack_uint32(&buffer); /* uint32 : smeBuild */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.versions.smeVariant = event_unpack_uint32(&buffer); /* uint32 : smeVariant */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.versions.smeDriverApi = event_unpack_uint32(&buffer); /* uint32 : smeDriverApi */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.versions.smeHip = event_unpack_uint32(&buffer); /* uint32 : smeHip */
        /*lint -save -e545 -e725 */
        evt.appValue.unifi_Value_union.versions.smeSapApi = event_unpack_uint32(&buffer); /* uint32 : smeSapApi */
        evt.appValue.unifi_Value_union.versions.smeIdString = event_unpack_string(&buffer); /* unifi_String : smeIdString */
        break;
    default:
        break;
    }
    /* -----------------------------------------------------------------*/

    unifi_mgt_get_value_cfm(context, evt.status, &evt.appValue);

    /* -----------------------------------------------------------------*/
    /* A UNION  :: unifi_Value_union*/
    /* -----------------------------------------------------------------*/
    switch(evt.appValue.id)
    {
    case unifi_AdHocConfigValue:
        break;
    case unifi_CalibrationDataValue:
        if (evt.appValue.unifi_Value_union.calibrationData.length)
        {
            osa_free(evt.appValue.unifi_Value_union.calibrationData.data); /*lint !e725 unifi_DataBlock : calibrationData*/
        }
        break;
    case unifi_CoexConfigValue:
        break;
    case unifi_CoexInfoValue:
        break;
    case unifi_ConnectionConfigValue:
        if (evt.appValue.unifi_Value_union.connectionConfig.mlmeAssociateReqInformationElements.length)
        {
            osa_free(evt.appValue.unifi_Value_union.connectionConfig.mlmeAssociateReqInformationElements.data); /*lint !e725 unifi_DataBlock : mlmeAssociateReqInformationElements*/
        }
        break;
    case unifi_ConnectionInfoValue:
        if (evt.appValue.unifi_Value_union.connectionInfo.assocScanInfoElements.length)
        {
            osa_free(evt.appValue.unifi_Value_union.connectionInfo.assocScanInfoElements.data); /*lint !e725 unifi_DataBlock : assocScanInfoElements*/
        }
        if (evt.appValue.unifi_Value_union.connectionInfo.assocReqInfoElements.length)
        {
            osa_free(evt.appValue.unifi_Value_union.connectionInfo.assocReqInfoElements.data); /*lint !e725 unifi_DataBlock : assocReqInfoElements*/
        }
        if (evt.appValue.unifi_Value_union.connectionInfo.assocRspInfoElements.length)
        {
            osa_free(evt.appValue.unifi_Value_union.connectionInfo.assocRspInfoElements.data); /*lint !e725 unifi_DataBlock : assocRspInfoElements*/
        }
        break;
    case unifi_ConnectionStatsValue:
        break;
    case unifi_HostConfigValue:
        break;
    case unifi_MIBConfigValue:
        break;
    case unifi_PermanentMacAddressValue:
        break;
    case unifi_PowerConfigValue:
        break;
    case unifi_RoamingConfigValue:
        break;
    case unifi_SMEConfigValue:
        break;
    case unifi_ScanConfigValue:
        if (evt.appValue.unifi_Value_union.scanControl.passiveChannelList.length)
        {
            osa_free(evt.appValue.unifi_Value_union.scanControl.passiveChannelList.data); /*lint !e725 unifi_DataBlock : passiveChannelList*/
        }
        break;
    case unifi_StationMacAddressValue:
        break;
    case unifi_VersionsValue:
        osa_free(evt.appValue.unifi_Value_union.versions.smeIdString); /* unifi_String : smeIdString */
        break;
    default:
        break;
    }
    /* -----------------------------------------------------------------*/
}

static void event_to_unifi_mgt_mib_set_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtMibSetCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */

    unifi_mgt_mib_set_cfm(context, evt.status);

}

static void event_to_unifi_mgt_mib_get_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtMibGetCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */
    evt.mibAttributeValue.length = event_unpack_uint16(&buffer); /*lint !e725 unifi_DataBlock : mibAttributeValue */
    evt.mibAttributeValue.data = NULL;
    if (evt.mibAttributeValue.length)
    {
        evt.mibAttributeValue.data = (uint8*)osa_malloc(evt.mibAttributeValue.length); /*lint !e725 unifi_DataBlock : mibAttributeValue*/
        /*lint -save -e545 -e725 */
        event_unpack_buffer(&buffer, evt.mibAttributeValue.data, evt.mibAttributeValue.length); /*lint !e545 !e725 unifi_DataBlock : mibAttributeValue */
    }

    unifi_mgt_mib_get_cfm(context, evt.status, &evt.mibAttributeValue);

    if (evt.mibAttributeValue.length)
    {
        osa_free(evt.mibAttributeValue.data); /*lint !e725 unifi_DataBlock : mibAttributeValue*/
    }
}

static void event_to_unifi_mgt_mib_get_next_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtMibGetNextCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */
    evt.mibAttribute.length = event_unpack_uint16(&buffer); /*lint !e725 unifi_DataBlock : mibAttribute */
    evt.mibAttribute.data = NULL;
    if (evt.mibAttribute.length)
    {
        evt.mibAttribute.data = (uint8*)osa_malloc(evt.mibAttribute.length); /*lint !e725 unifi_DataBlock : mibAttribute*/
        /*lint -save -e545 -e725 */
        event_unpack_buffer(&buffer, evt.mibAttribute.data, evt.mibAttribute.length); /*lint !e545 !e725 unifi_DataBlock : mibAttribute */
    }

    unifi_mgt_mib_get_next_cfm(context, evt.status, &evt.mibAttribute);

    if (evt.mibAttribute.length)
    {
        osa_free(evt.mibAttribute.data); /*lint !e725 unifi_DataBlock : mibAttribute*/
    }
}

static void event_to_unifi_mgt_scan_full_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtScanFullCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */

    unifi_mgt_scan_full_cfm(context, evt.status);

}

static void event_to_unifi_mgt_scan_results_get_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtScanResultsGetCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */
    /*lint -save -e545 -e725 */
    evt.resultsBuffer.numElements = event_unpack_uint16(&buffer); /* uint16 : numElements */
    evt.resultsBuffer.results = NULL;
    if (evt.resultsBuffer.numElements)
    {
        int i;
        evt.resultsBuffer.results = (unifi_ScanResult*)osa_malloc(sizeof(unifi_ScanResult) * evt.resultsBuffer.numElements);
        for (i=0; i < evt.resultsBuffer.numElements; i++)
        {
            /*lint -save -e545 -e725 */
            event_unpack_buffer(&buffer, (uint8*)&evt.resultsBuffer.results[i].ssid.ssid, 32); /*lint !e545 !e725  uint8 : ssid */
            /*lint -save -e545 -e725 */
            evt.resultsBuffer.results[i].ssid.length = event_unpack_uint8(&buffer); /* uint8 : length */
            /*lint -save -e545 -e725 */
            event_unpack_buffer(&buffer, (uint8*)&evt.resultsBuffer.results[i].bssid.data, 6); /*lint !e545 !e725  uint8 : data */
            /*lint -save -e545 -e725 */
            evt.resultsBuffer.results[i].rssi = event_unpack_int16(&buffer); /* int16 : rssi */
            /*lint -save -e545 -e725 */
            evt.resultsBuffer.results[i].snr = event_unpack_int16(&buffer); /* int16 : snr */
            /*lint -save -e545 -e725 */
            evt.resultsBuffer.results[i].ifIndex = event_unpack_uint16(&buffer); /* unifi_RadioIF : ifIndex */
            /*lint -save -e545 -e725 */
            evt.resultsBuffer.results[i].beaconPeriod = event_unpack_uint16(&buffer); /* uint16 : beaconPeriod */
            /*lint -save -e545 -e725 */
            event_unpack_buffer(&buffer, (uint8*)&evt.resultsBuffer.results[i].timestamp.data, 8); /*lint !e545 !e725  uint8 : data */
            /*lint -save -e545 -e725 */
            event_unpack_buffer(&buffer, (uint8*)&evt.resultsBuffer.results[i].localTime.data, 8); /*lint !e545 !e725  uint8 : data */
            /*lint -save -e545 -e725 */
            evt.resultsBuffer.results[i].channelFrequency = event_unpack_uint16(&buffer); /* uint16 : channelFrequency */
            /*lint -save -e545 -e725 */
            evt.resultsBuffer.results[i].capabilityInformation = event_unpack_uint16(&buffer); /* uint16 : capabilityInformation */
            /*lint -save -e545 -e725 */
            evt.resultsBuffer.results[i].channelNumber = event_unpack_uint8(&buffer); /* uint8 : channelNumber */
            /*lint -save -e545 -e725 */
            evt.resultsBuffer.results[i].usability = event_unpack_uint16(&buffer); /* unifi_BasicUsability : usability */
            /*lint -save -e545 -e725 */
            evt.resultsBuffer.results[i].bssType = event_unpack_uint16(&buffer); /* unifi_BSSType : bssType */
            evt.resultsBuffer.results[i].informationElements.length = event_unpack_uint16(&buffer); /*lint !e725 unifi_DataBlock : informationElements */
            evt.resultsBuffer.results[i].informationElements.data = NULL;
            if (evt.resultsBuffer.results[i].informationElements.length)
            {
                evt.resultsBuffer.results[i].informationElements.data = (uint8*)osa_malloc(evt.resultsBuffer.results[i].informationElements.length); /*lint !e725 unifi_DataBlock : informationElements*/
                /*lint -save -e545 -e725 */
                event_unpack_buffer(&buffer, evt.resultsBuffer.results[i].informationElements.data, evt.resultsBuffer.results[i].informationElements.length); /*lint !e545 !e725 unifi_DataBlock : informationElements */
            }
        }
    }

    unifi_mgt_scan_results_get_cfm(context, evt.status, &evt.resultsBuffer);

    if (evt.resultsBuffer.numElements)
    {
        int i;
        for (i=0; i < evt.resultsBuffer.numElements; i++)
        {
            if (evt.resultsBuffer.results[i].informationElements.length)
            {
                osa_free(evt.resultsBuffer.results[i].informationElements.data); /*lint !e725 unifi_DataBlock : informationElements*/
            }
        }
        osa_free(evt.resultsBuffer.results);
    }
}

static void event_to_unifi_mgt_scan_result_ind(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtScanResultInd_Evt evt;
    /*lint -save -e545 -e725 */
    event_unpack_buffer(&buffer, (uint8*)&evt.result.ssid.ssid, 32); /*lint !e545 !e725  uint8 : ssid */
    /*lint -save -e545 -e725 */
    evt.result.ssid.length = event_unpack_uint8(&buffer); /* uint8 : length */
    /*lint -save -e545 -e725 */
    event_unpack_buffer(&buffer, (uint8*)&evt.result.bssid.data, 6); /*lint !e545 !e725  uint8 : data */
    /*lint -save -e545 -e725 */
    evt.result.rssi = event_unpack_int16(&buffer); /* int16 : rssi */
    /*lint -save -e545 -e725 */
    evt.result.snr = event_unpack_int16(&buffer); /* int16 : snr */
    /*lint -save -e545 -e725 */
    evt.result.ifIndex = event_unpack_uint16(&buffer); /* unifi_RadioIF : ifIndex */
    /*lint -save -e545 -e725 */
    evt.result.beaconPeriod = event_unpack_uint16(&buffer); /* uint16 : beaconPeriod */
    /*lint -save -e545 -e725 */
    event_unpack_buffer(&buffer, (uint8*)&evt.result.timestamp.data, 8); /*lint !e545 !e725  uint8 : data */
    /*lint -save -e545 -e725 */
    event_unpack_buffer(&buffer, (uint8*)&evt.result.localTime.data, 8); /*lint !e545 !e725  uint8 : data */
    /*lint -save -e545 -e725 */
    evt.result.channelFrequency = event_unpack_uint16(&buffer); /* uint16 : channelFrequency */
    /*lint -save -e545 -e725 */
    evt.result.capabilityInformation = event_unpack_uint16(&buffer); /* uint16 : capabilityInformation */
    /*lint -save -e545 -e725 */
    evt.result.channelNumber = event_unpack_uint8(&buffer); /* uint8 : channelNumber */
    /*lint -save -e545 -e725 */
    evt.result.usability = event_unpack_uint16(&buffer); /* unifi_BasicUsability : usability */
    /*lint -save -e545 -e725 */
    evt.result.bssType = event_unpack_uint16(&buffer); /* unifi_BSSType : bssType */
    evt.result.informationElements.length = event_unpack_uint16(&buffer); /*lint !e725 unifi_DataBlock : informationElements */
    evt.result.informationElements.data = NULL;
    if (evt.result.informationElements.length)
    {
        evt.result.informationElements.data = (uint8*)osa_malloc(evt.result.informationElements.length); /*lint !e725 unifi_DataBlock : informationElements*/
        /*lint -save -e545 -e725 */
        event_unpack_buffer(&buffer, evt.result.informationElements.data, evt.result.informationElements.length); /*lint !e545 !e725 unifi_DataBlock : informationElements */
    }

    unifi_mgt_scan_result_ind(context, &evt.result);

    if (evt.result.informationElements.length)
    {
        osa_free(evt.result.informationElements.data); /*lint !e725 unifi_DataBlock : informationElements*/
    }
}

static void event_to_unifi_mgt_connect_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtConnectCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */

    unifi_mgt_connect_cfm(context, evt.status);

}

static void event_to_unifi_mgt_media_status_ind(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtMediaStatusInd_Evt evt;
    /*lint -save -e545 -e725 */
    evt.mediaStatus = event_unpack_uint16(&buffer); /* unifi_MediaStatus : mediaStatus */
    /*lint -save -e545 -e725 */
    event_unpack_buffer(&buffer, (uint8*)&evt.connectionInfo.ssid.ssid, 32); /*lint !e545 !e725  uint8 : ssid */
    /*lint -save -e545 -e725 */
    evt.connectionInfo.ssid.length = event_unpack_uint8(&buffer); /* uint8 : length */
    /*lint -save -e545 -e725 */
    event_unpack_buffer(&buffer, (uint8*)&evt.connectionInfo.bssid.data, 6); /*lint !e545 !e725  uint8 : data */
    /*lint -save -e545 -e725 */
    evt.connectionInfo.networkType80211 = event_unpack_uint16(&buffer); /* unifi_80211_NetworkType : networkType80211 */
    /*lint -save -e545 -e725 */
    evt.connectionInfo.channelNumber = event_unpack_uint8(&buffer); /* uint8 : channelNumber */
    /*lint -save -e545 -e725 */
    evt.connectionInfo.channelFrequency = event_unpack_uint16(&buffer); /* uint16 : channelFrequency */
    /*lint -save -e545 -e725 */
    evt.connectionInfo.authMode = event_unpack_uint16(&buffer); /* unifi_AuthMode : authMode */
    /*lint -save -e545 -e725 */
    evt.connectionInfo.ifIndex = event_unpack_uint16(&buffer); /* unifi_RadioIF : ifIndex */
    /*lint -save -e545 -e725 */
    evt.connectionInfo.atimWindow = event_unpack_uint16(&buffer); /* uint16 : atimWindow */
    /*lint -save -e545 -e725 */
    evt.connectionInfo.beaconPeriod = event_unpack_uint16(&buffer); /* uint16 : beaconPeriod */
    evt.connectionInfo.assocScanInfoElements.length = event_unpack_uint16(&buffer); /*lint !e725 unifi_DataBlock : assocScanInfoElements */
    evt.connectionInfo.assocScanInfoElements.data = NULL;
    if (evt.connectionInfo.assocScanInfoElements.length)
    {
        evt.connectionInfo.assocScanInfoElements.data = (uint8*)osa_malloc(evt.connectionInfo.assocScanInfoElements.length); /*lint !e725 unifi_DataBlock : assocScanInfoElements*/
        /*lint -save -e545 -e725 */
        event_unpack_buffer(&buffer, evt.connectionInfo.assocScanInfoElements.data, evt.connectionInfo.assocScanInfoElements.length); /*lint !e545 !e725 unifi_DataBlock : assocScanInfoElements */
    }
    /*lint -save -e545 -e725 */
    evt.connectionInfo.assocReqCapabilities = event_unpack_uint16(&buffer); /* uint16 : assocReqCapabilities */
    /*lint -save -e545 -e725 */
    evt.connectionInfo.assocReqListenInterval = event_unpack_uint16(&buffer); /* uint16 : assocReqListenInterval */
    /*lint -save -e545 -e725 */
    event_unpack_buffer(&buffer, (uint8*)&evt.connectionInfo.assocReqApAddress.data, 6); /*lint !e545 !e725  uint8 : data */
    evt.connectionInfo.assocReqInfoElements.length = event_unpack_uint16(&buffer); /*lint !e725 unifi_DataBlock : assocReqInfoElements */
    evt.connectionInfo.assocReqInfoElements.data = NULL;
    if (evt.connectionInfo.assocReqInfoElements.length)
    {
        evt.connectionInfo.assocReqInfoElements.data = (uint8*)osa_malloc(evt.connectionInfo.assocReqInfoElements.length); /*lint !e725 unifi_DataBlock : assocReqInfoElements*/
        /*lint -save -e545 -e725 */
        event_unpack_buffer(&buffer, evt.connectionInfo.assocReqInfoElements.data, evt.connectionInfo.assocReqInfoElements.length); /*lint !e545 !e725 unifi_DataBlock : assocReqInfoElements */
    }
    /*lint -save -e545 -e725 */
    evt.connectionInfo.assocRspResult = event_unpack_uint16(&buffer); /* unifi_IEEE80211_Result : assocRspResult */
    /*lint -save -e545 -e725 */
    evt.connectionInfo.assocRspCapabilityInfo = event_unpack_uint16(&buffer); /* uint16 : assocRspCapabilityInfo */
    /*lint -save -e545 -e725 */
    evt.connectionInfo.assocRspAssociationId = event_unpack_uint16(&buffer); /* uint16 : assocRspAssociationId */
    evt.connectionInfo.assocRspInfoElements.length = event_unpack_uint16(&buffer); /*lint !e725 unifi_DataBlock : assocRspInfoElements */
    evt.connectionInfo.assocRspInfoElements.data = NULL;
    if (evt.connectionInfo.assocRspInfoElements.length)
    {
        evt.connectionInfo.assocRspInfoElements.data = (uint8*)osa_malloc(evt.connectionInfo.assocRspInfoElements.length); /*lint !e725 unifi_DataBlock : assocRspInfoElements*/
        /*lint -save -e545 -e725 */
        event_unpack_buffer(&buffer, evt.connectionInfo.assocRspInfoElements.data, evt.connectionInfo.assocRspInfoElements.length); /*lint !e545 !e725 unifi_DataBlock : assocRspInfoElements */
    }

    unifi_mgt_media_status_ind(context, evt.mediaStatus, &evt.connectionInfo);

    if (evt.connectionInfo.assocScanInfoElements.length)
    {
        osa_free(evt.connectionInfo.assocScanInfoElements.data); /*lint !e725 unifi_DataBlock : assocScanInfoElements*/
    }
    if (evt.connectionInfo.assocReqInfoElements.length)
    {
        osa_free(evt.connectionInfo.assocReqInfoElements.data); /*lint !e725 unifi_DataBlock : assocReqInfoElements*/
    }
    if (evt.connectionInfo.assocRspInfoElements.length)
    {
        osa_free(evt.connectionInfo.assocRspInfoElements.data); /*lint !e725 unifi_DataBlock : assocRspInfoElements*/
    }
}

static void event_to_unifi_mgt_connection_quality_ind(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtConnectionQualityInd_Evt evt;
    /*lint -save -e545 -e725 */
    evt.connectionStats.unifiRSSI = event_unpack_int16(&buffer); /* int16 : unifiRSSI */
    /*lint -save -e545 -e725 */
    evt.connectionStats.unifiSNR = event_unpack_int16(&buffer); /* int16 : unifiSNR */
    /*lint -save -e545 -e725 */
    evt.connectionStats.unifiTxDataRate = event_unpack_uint8(&buffer); /* uint8 : unifiTxDataRate */
    /*lint -save -e545 -e725 */
    evt.connectionStats.unifiRxDataRate = event_unpack_uint8(&buffer); /* uint8 : unifiRxDataRate */
    /*lint -save -e545 -e725 */
    evt.connectionStats.dot11RetryCount = event_unpack_uint32(&buffer); /* uint32 : dot11RetryCount */
    /*lint -save -e545 -e725 */
    evt.connectionStats.dot11MultipleRetryCount = event_unpack_uint32(&buffer); /* uint32 : dot11MultipleRetryCount */
    /*lint -save -e545 -e725 */
    evt.connectionStats.dot11ACKFailureCount = event_unpack_uint32(&buffer); /* uint32 : dot11ACKFailureCount */
    /*lint -save -e545 -e725 */
    evt.connectionStats.dot11FrameDuplicateCount = event_unpack_uint32(&buffer); /* uint32 : dot11FrameDuplicateCount */
    /*lint -save -e545 -e725 */
    evt.connectionStats.dot11FCSErrorCount = event_unpack_uint32(&buffer); /* uint32 : dot11FCSErrorCount */
    /*lint -save -e545 -e725 */
    evt.connectionStats.dot11RTSSuccessCount = event_unpack_uint32(&buffer); /* uint32 : dot11RTSSuccessCount */
    /*lint -save -e545 -e725 */
    evt.connectionStats.dot11RTSFailureCount = event_unpack_uint32(&buffer); /* uint32 : dot11RTSFailureCount */
    /*lint -save -e545 -e725 */
    evt.connectionStats.dot11ReceivedFragmentCount = event_unpack_uint32(&buffer); /* uint32 : dot11ReceivedFragmentCount */
    /*lint -save -e545 -e725 */
    evt.connectionStats.dot11TransmittedFragmentCount = event_unpack_uint32(&buffer); /* uint32 : dot11TransmittedFragmentCount */

    unifi_mgt_connection_quality_ind(context, &evt.connectionStats);

}

static void event_to_unifi_mgt_disconnect_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtDisconnectCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */

    unifi_mgt_disconnect_cfm(context, evt.status);

}

static void event_to_unifi_mgt_multicast_address_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtMulticastAddressCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */
    /*lint -save -e545 -e725 */
    evt.action = event_unpack_uint16(&buffer); /* unifi_ListAction : action */
    /*lint -save -e545 -e725 */
    evt.getAddresses.numElements = event_unpack_uint8(&buffer); /* uint8 : numElements */
    evt.getAddresses.addresses = NULL;
    if (evt.getAddresses.numElements)
    {
        int i;
        evt.getAddresses.addresses = (unifi_MACAddress*)osa_malloc(sizeof(unifi_MACAddress) * evt.getAddresses.numElements);
        for (i=0; i < evt.getAddresses.numElements; i++)
        {
            /*lint -save -e545 -e725 */
            event_unpack_buffer(&buffer, (uint8*)&evt.getAddresses.addresses[i].data, 6); /*lint !e545 !e725  uint8 : data */
        }
    }

    unifi_mgt_multicast_address_cfm(context, evt.status, evt.action, &evt.getAddresses);

    if (evt.getAddresses.numElements)
    {
        int i;
        for (i=0; i < evt.getAddresses.numElements; i++)
        {
        }
        osa_free(evt.getAddresses.addresses);
    }
}

static void event_to_unifi_mgt_mic_failure_ind(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtMicFailureInd_Evt evt;
    /*lint -save -e545 -e725 */
    evt.secondFailure = event_unpack_int16(&buffer); /* Boolean : secondFailure */
    /*lint -save -e545 -e725 */
    evt.count = event_unpack_uint16(&buffer); /* uint16 : count */
    /*lint -save -e545 -e725 */
    event_unpack_buffer(&buffer, (uint8*)&evt.address.data, 6); /*lint !e545 !e725  uint8 : data */
    /*lint -save -e545 -e725 */
    evt.keyType = event_unpack_uint16(&buffer); /* unifi_KeyType : keyType */
    /*lint -save -e545 -e725 */
    evt.keyId = event_unpack_uint16(&buffer); /* uint16 : keyId */
    /*lint -save -e545 -e725 */
    event_unpack_buffer(&buffer, (uint8*)&evt.tSC.data, 8); /*lint !e545 !e725  uint8 : data */

    unifi_mgt_mic_failure_ind(context, evt.secondFailure, evt.count, &evt.address, evt.keyType, evt.keyId, &evt.tSC);

}

static void event_to_unifi_mgt_pmkid_candidate_list_ind(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtPmkidCandidateListInd_Evt evt;
    /*lint -save -e545 -e725 */
    evt.candidates.numElements = event_unpack_uint8(&buffer); /* uint8 : numElements */
    evt.candidates.pmkidCandidates = NULL;
    if (evt.candidates.numElements)
    {
        int i;
        evt.candidates.pmkidCandidates = (unifi_PmkidCandidate*)osa_malloc(sizeof(unifi_PmkidCandidate) * evt.candidates.numElements);
        for (i=0; i < evt.candidates.numElements; i++)
        {
            /*lint -save -e545 -e725 */
            event_unpack_buffer(&buffer, (uint8*)&evt.candidates.pmkidCandidates[i].bssid.data, 6); /*lint !e545 !e725  uint8 : data */
            /*lint -save -e545 -e725 */
            evt.candidates.pmkidCandidates[i].preAuthAllowed = event_unpack_int16(&buffer); /* Boolean : preAuthAllowed */
        }
    }

    unifi_mgt_pmkid_candidate_list_ind(context, &evt.candidates);

    if (evt.candidates.numElements)
    {
        int i;
        for (i=0; i < evt.candidates.numElements; i++)
        {
        }
        osa_free(evt.candidates.pmkidCandidates);
    }
}

static void event_to_unifi_mgt_pmkid_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtPmkidCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */
    /*lint -save -e545 -e725 */
    evt.action = event_unpack_uint16(&buffer); /* unifi_ListAction : action */
    /*lint -save -e545 -e725 */
    evt.getPmkidList.numElements = event_unpack_uint8(&buffer); /* uint8 : numElements */
    evt.getPmkidList.pmkids = NULL;
    if (evt.getPmkidList.numElements)
    {
        int i;
        evt.getPmkidList.pmkids = (unifi_Pmkid*)osa_malloc(sizeof(unifi_Pmkid) * evt.getPmkidList.numElements);
        for (i=0; i < evt.getPmkidList.numElements; i++)
        {
            /*lint -save -e545 -e725 */
            event_unpack_buffer(&buffer, (uint8*)&evt.getPmkidList.pmkids[i].bssid.data, 6); /*lint !e545 !e725  uint8 : data */
            /*lint -save -e545 -e725 */
            event_unpack_buffer(&buffer, (uint8*)&evt.getPmkidList.pmkids[i].pmkid, 16); /*lint !e545 !e725  uint8 : pmkid */
        }
    }

    unifi_mgt_pmkid_cfm(context, evt.status, evt.action, &evt.getPmkidList);

    if (evt.getPmkidList.numElements)
    {
        int i;
        for (i=0; i < evt.getPmkidList.numElements; i++)
        {
        }
        osa_free(evt.getPmkidList.pmkids);
    }
}

static void event_to_unifi_mgt_key_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtKeyCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */
    /*lint -save -e545 -e725 */
    evt.action = event_unpack_uint16(&buffer); /* unifi_ListAction : action */

    unifi_mgt_key_cfm(context, evt.status, evt.action);

}

static void event_to_unifi_mgt_packet_filter_set_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtPacketFilterSetCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */

    unifi_mgt_packet_filter_set_cfm(context, evt.status);

}

static void event_to_unifi_mgt_tspec_cfm(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtTspecCfm_Evt evt;
    /*lint -save -e545 -e725 */
    evt.status = event_unpack_uint16(&buffer); /* unifi_Status : status */
    /*lint -save -e545 -e725 */
    evt.transactionId = event_unpack_uint32(&buffer); /* uint32 : transactionId */
    /*lint -save -e545 -e725 */
    evt.tspecResultCode = event_unpack_uint16(&buffer); /* unifi_TspecResultCode : tspecResultCode */
    evt.tspec.length = event_unpack_uint16(&buffer); /*lint !e725 unifi_DataBlock : tspec */
    evt.tspec.data = NULL;
    if (evt.tspec.length)
    {
        evt.tspec.data = (uint8*)osa_malloc(evt.tspec.length); /*lint !e725 unifi_DataBlock : tspec*/
        /*lint -save -e545 -e725 */
        event_unpack_buffer(&buffer, evt.tspec.data, evt.tspec.length); /*lint !e545 !e725 unifi_DataBlock : tspec */
    }

    unifi_mgt_tspec_cfm(context, evt.status, evt.transactionId, evt.tspecResultCode, &evt.tspec);

    if (evt.tspec.length)
    {
        osa_free(evt.tspec.data); /*lint !e725 unifi_DataBlock : tspec*/
    }
}

static void event_to_unifi_mgt_tspec_ind(FsmContext* context, uint8* inputbuffer, uint16 size)
{
    uint8* buffer = &inputbuffer[6];
    UnifiMgtTspecInd_Evt evt;
    /*lint -save -e545 -e725 */
    evt.action = event_unpack_uint16(&buffer); /* unifi_ListAction : action */
    /*lint -save -e545 -e725 */
    evt.transactionId = event_unpack_uint32(&buffer); /* uint32 : transactionId */

    unifi_mgt_tspec_ind(context, evt.action, evt.transactionId);

}

typedef void (*event_to_fn)(FsmContext* context, uint8* inputbuffer, uint16 size);
static const event_to_fn fnlookup[41] = {
        NULL,
        event_to_unifi_mgt_wifi_on_cfm,
        NULL,
        event_to_unifi_mgt_wifi_off_cfm,
        event_to_unifi_mgt_wifi_off_ind,
        NULL,
        event_to_unifi_mgt_wifi_flightmode_cfm,
        NULL,
        event_to_unifi_mgt_set_value_cfm,
        NULL,
        event_to_unifi_mgt_get_value_cfm,
        NULL,
        event_to_unifi_mgt_mib_set_cfm,
        NULL,
        event_to_unifi_mgt_mib_get_cfm,
        NULL,
        event_to_unifi_mgt_mib_get_next_cfm,
        NULL,
        event_to_unifi_mgt_scan_full_cfm,
        NULL,
        event_to_unifi_mgt_scan_results_get_cfm,
        event_to_unifi_mgt_scan_result_ind,
        NULL,
        event_to_unifi_mgt_connect_cfm,
        event_to_unifi_mgt_media_status_ind,
        event_to_unifi_mgt_connection_quality_ind,
        NULL,
        event_to_unifi_mgt_disconnect_cfm,
        NULL,
        event_to_unifi_mgt_multicast_address_cfm,
        event_to_unifi_mgt_mic_failure_ind,
        event_to_unifi_mgt_pmkid_candidate_list_ind,
        NULL,
        event_to_unifi_mgt_pmkid_cfm,
        NULL,
        event_to_unifi_mgt_key_cfm,
        NULL,
        event_to_unifi_mgt_packet_filter_set_cfm,
        NULL,
        event_to_unifi_mgt_tspec_cfm,
        event_to_unifi_mgt_tspec_ind,
};

Boolean remote_mgt_signal_receive(FsmContext* context, uint8* buffer, uint16 size)
{
    uint8* tempbuffer = buffer;
    uint16 id = event_unpack_uint16(&tempbuffer);
    uint16 idx = id - 0x9001;

    if (idx < 41)
    {
         if (fnlookup[idx])
         {
           (*fnlookup[idx])(context, buffer, size);
           return TRUE;
         }
    }
    return FALSE;
}

